﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Runtime.Serialization;

namespace TestProject1
{

    [ServiceContract]
    public interface IGeneric
    {
        [OperationContract(Action="*",ReplyAction="*")]
        Message Execute(Message argument);
    }

    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class UnitTest1
    {
        public UnitTest1()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [DataContract]
        public class ComboArgument
        {
            [DataMember]
            public int Arg1;
            
            [DataMember]
            public string Arg2;
        }

        [TestMethod]
        public void TestMethod1()
        {
            var fac = new ChannelFactory<IGeneric>("facade");
            var proxy = fac.CreateChannel();
            var retVal = proxy.Execute(Message.CreateMessage(fac.Endpoint.Binding.MessageVersion,
                                                             "http://docombo/request",
                                                             new ComboArgument { Arg1 = 33, Arg2 = "Going into the facade" }));
            Console.WriteLine(retVal);

        }
    }
}
